    <?php # Skrypt 4.4 - custom_auth.php

    /*  W tym skrypcie wykorzystano pakiet PEAR Auth do kontroli dostpu.
     *  Zaoono w nim, e istnieje baza danych "auth",
     *  do ktrej ma dostp uytkownik MySQL "uzytkownik@localhost"
     *  uywajcy hasa "haslo".
     *  Definicja tabeli:
        CREATE TABLE uzytkownicy (
       id_uzytkownika INT UNSIGNED NOT NULL AUTO_INCREMENT, 
       email VARCHAR(60) NOT NULL,
       haslo CHAR(40) NOT NULL,
       imie VARCHAR (20) NOT NULL,
       nazwisko VARCHAR(40) NOT NULL,
       PRIMARY KEY (id_uzytkownika);
       UNIQUE (email),
       KEY (email, haslo)
       )
    *   Do zaszyfrowania hasa uyto funkcji SHA1().
    */

   // Potrzebna jest klasa PEAR:
    require_once ('Auth.php');

   // Funkcja wywietlajca formularz logowania:
   function show_login_form() {

        echo '<form method="post" action="custom_auth.php">
    <p>Email <input type="text" name="username" /></p>
    <p>Haso <input type="password" name="password" /></p>
    <input type="submit" value="Zaloguj si" />
    </form><br />
    ';
  } // Koniec funkcji show_login_form().

    // Wszystkie opcje:
    // Wykorzystanie podanych kolumn z nazw uytkownika i hasem.
    // Wykorzystanie funkcji SHA1() do zaszyfrowania hasa.
    // Pobranie wszystkich pl.
    $options = array(
    'dsn' => 'mysql://root:@localhost/auth',
    'table' => 'uzytkownicy',
    'usernamecol' => 'email',
    'passwordcol' => 'haslo',
    'cryptType' => 'sha1',
    'db_fields' => '*'
    );

    // Utworzenie obiektu Auth:
    $auth = new Auth('DB', $options, 'show_login_form');

    // Dodanie nowego uytkownika:
    $auth->addUser('ja@przyklad.pl', 'mojehaslo', array('imie' => 'Larry', 'nazwisko' => 'Ullman'));

     ?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//PL"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
    <html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="pl">
    <head>
        <meta http-equiv="content-type" content="text/html; charset=windows-1250" />
         <title>Strona zastrzeona</title>
     </head>
     <body>
     <?php

     // Rozpoczcie autoryzacji:
     $auth->start();

     // Potwierdzenie autoryzacji:
     if ($auth->checkAuth()) {

        // Wywietlenie nazwy uytkownika:
        echo "<p>{$auth->getAuthData('imie')} {$auth->getAuthData('nazwisko')}, zalogowae si w systemie i moesz przeczyta ten komunikat. wietnie, prawda?</p>";

   } else { // Uytkownik nieuprawniony.

      echo '<p>Dostp do tej strony wymaga zalogowania si w systemie.</p>';

     }

     ?>
   </body>
   </html>